*-----------------------------------------------------------------------
*-- File........: Printer.H
*-- Programmer..: Bowen Moursund (CIS: 72662,436), Copyright 1997
*-- Date........: 02/28/97
*-----------------------------------------------------------------------

*-- miscellaneous inline functions
#define MAKE8(cBuff, nIndex)    Asc(SubStr(cBuff, nIndex))

#define MAKEU16(cBuff, nIndex)  MAKE8(cBuff, nIndex) +;
                                BitLShift(MAKE8(cBuff, nIndex + 1), 8)

#define MAKES16(cBuff, nIndex)  IIf(Asc(SubStr(cBuff, nIndex + 1, 1)) > 127,;
                                -BitXOr(MAKEU16(cBuff, nIndex), 65535) - 1,;
                                MAKEU16(cBuff, nIndex))

#define MAKEU32(cBuff, nIndex)  MAKE8(cBuff, nIndex) +;
                                BitLShift(MAKE8(cBuff, nIndex + 1), 8) +;
                                BitLShift(MAKE8(cBuff, nIndex + 2), 16) +;
                                BitLShift(MAKE8(cBuff, nIndex + 3), 24)

#define STORE8(nVal)            (Chr(BitAnd(nVal, 255)))

#define STORE16(nVal)           STORE8(nval) +;
                                STORE8(BitRShift(nVal, 8))

#define STORE32(nVal)           STORE8(nval) +;
                                STORE8(BitRShift(nVal, 8)) +;
                                STORE8(BitRShift(nVal, 16)) +;
                                STORE8(BitRShift(nVal, 24))

*-- mode selections for the device mode function
#define DM_UPDATE           1
#define DM_COPY             2
#define DM_PROMPT           4
#define DM_MODIFY           8

*-- devmode field selection flags
#define DM_ORIENTATION      1
#define DM_PAPERSIZE        2
#define DM_PAPERLENGTH      4
#define DM_PAPERWIDTH       8
#define DM_SCALE            16
#define DM_COPIES           256
#define DM_DEFAULTSOURCE    512
#define DM_PRINTQUALITY     1024
#define DM_COLOR            2048
#define DM_DUPLEX           4096
#define DM_YRESOLUTION      8192
#define DM_TTOPTION         16384

*-- device capabilities indices
#define DC_FIELDS           1
#define DC_PAPERS           2
#define DC_PAPERSIZE        3
#define DC_MINEXTENT        4
#define DC_MAXEXTENT        5
#define DC_BINS             6
#define DC_DUPLEX           7
#define DC_SIZE             8
#define DC_EXTRA            9
#define DC_VERSION          10
#define DC_DRIVER           11
#define DC_BINNAMES         12
#define DC_ENUMRESOLUTIONS  13
#define DC_FILEDEPENDENCIES 14
#define DC_TRUETYPE         15
#define DC_PAPERNAMES       16
#define DC_ORIENTATION      17
#define DC_COPIES           18
#define DC_ORIENTATION      17

*-- page orientation selections
#define DMORIENT_PORTRAIT   1
#define DMORIENT_LANDSCAPE  2

*-- paper sizes
*-- Letter 8 1/2 x 11 in
#define DMPAPER_LETTER      1
*-- Letter Small 8 1/2 x 11 in
#define DMPAPER_LETTERSMALL 2
*-- Tabloid 11 x 17 in
#define DMPAPER_TABLOID     3
*-- Ledger 17 x 11 in
#define DMPAPER_LEDGER      4
*-- Legal 8 1/2 x 14 in
#define DMPAPER_LEGAL       5
*-- Statement 5 1/2 x 8 1/2 in
#define DMPAPER_STATEMENT   6
*-- Executive 7 1/4 x 10 1/2 in
#define DMPAPER_EXECUTIVE   7
*-- A3 297 x 420 mm
#define DMPAPER_A3          8
*-- A4 210 x 297 mm
#define DMPAPER_A4          9
*-- A4 Small 210 x 297 mm
#define DMPAPER_A4SMALL     10
*-- A5 148 x 210 mm
#define DMPAPER_A5          11
*-- B4 250 x 354
#define DMPAPER_B4          12
*-- B5 182 x 257 mm
#define DMPAPER_B5          13
*-- Folio 8 1/2 x 13 in
#define DMPAPER_FOLIO       14
*-- Quarto 215 x 275 mm
#define DMPAPER_QUARTO      15
*-- 10x14 in
#define DMPAPER_10X14       16
*-- 11x17 in
#define DMPAPER_11X17       17
*-- Note 8 1/2 x 11 in
#define DMPAPER_NOTE        18
*-- Envelope #9 3 7/8 x 8 7/8
#define DMPAPER_ENV_9       19
*-- Envelope #10 4 1/8 x 9 1/2
#define DMPAPER_ENV_10      20
*-- Envelope #11 4 1/2 x 10 3/8
#define DMPAPER_ENV_11      21
*-- Envelope #12 4 \276 x 11
#define DMPAPER_ENV_12      22
*-- Envelope #14 5 x 11 1/2
#define DMPAPER_ENV_14      23
*-- C size sheet
#define DMPAPER_CSHEET      24
*-- D size sheet
#define DMPAPER_DSHEET      25
*-- E size sheet
#define DMPAPER_ESHEET      26
*-- Envelope DL 110 x 220mm
#define DMPAPER_ENV_DL      27
*-- Envelope C5 162 x 229 mm
#define DMPAPER_ENV_C5      28
*-- Envelope C3  324 x 458 mm
#define DMPAPER_ENV_C3      29
*-- Envelope C4  229 x 324 mm
#define DMPAPER_ENV_C4      30
*-- Envelope C6  114 x 162 mm
#define DMPAPER_ENV_C6      31
*-- Envelope C65 114 x 229 mm
#define DMPAPER_ENV_C65     32
*-- Envelope B4  250 x 353 mm
#define DMPAPER_ENV_B4      33
*-- Envelope B5  176 x 250 mm
#define DMPAPER_ENV_B5      34
*-- Envelope B6  176 x 125 mm
#define DMPAPER_ENV_B6      35
*-- Envelope 110 x 230 mm
#define DMPAPER_ENV_ITALY   36
*-- Envelope Monarch 3.875 x 7.5 in
#define DMPAPER_ENV_MONARCH 37
*-- 6 3/4 Envelope 3 5/8 x 6 1/2 in
#define DMPAPER_ENV_PERSONAL 38
*-- US Std Fanfold 14 7/8 x 11 in
#define DMPAPER_FANFOLD_US  39
*-- German Std Fanfold 8 1/2 x 12 in
#define DMPAPER_FANFOLD_STD_GERMAN  40
*-- German Legal Fanfold 8 1/2 x 13 in
#define DMPAPER_FANFOLD_LGL_GERMAN  41
#define DMPAPER_FIRST     DMPAPER_LETTER
#define DMPAPER_LAST      DMPAPER_FANFOLD_LGL_GERMAN
#define DMPAPER_USER      256

*-- paper sources
#define DMBIN_UPPER         1
#define DMBIN_ONLYONE       1
#define DMBIN_LOWER         2
#define DMBIN_MIDDLE        3
#define DMBIN_MANUAL        4
#define DMBIN_ENVELOPE      5
#define DMBIN_ENVMANUAL     6
#define DMBIN_AUTO          7
#define DMBIN_TRACTOR       8
#define DMBIN_SMALLFMT      9
#define DMBIN_LARGEFMT      10
#define DMBIN_LARGECAPACITY 11
#define DMBIN_CASSETTE      14
#define DMBIN_FIRST         DMBIN_UPPER
#define DMBIN_LAST          DMBIN_CASSETTE
*-- device specific bins start here
#define DMBIN_USER          256

*-- printer resolution
#define DMRES_HIGH          -4
#define DMRES_MEDIUM        -3
#define DMRES_LOW           -2
#define DMRES_DRAFT         -1

*-- colors
#define DMCOLOR_COLOR       1
#define DMCOLOR_MONOCHROME  2

*-- duplex
#define DMDUP_SIMPLEX       1
#define DMDUP_HORIZONTAL    2
#define DMDUP_VERTICAL      3

*-- TrueType options
#define DMTT_BITMAP         1  && Print TT fonts as graphics
#define DMTT_DOWNLOAD       2  && Download TT fonts as soft fonts
#define DMTT_SUBDEV         3  && Substitute device fonts for TT fonts

if type("GetModuleHandle") <> "FP"
    extern CHANDLE GetModuleHandle(CSTRING) KRNL386.EXE
endif

*-- EoF: printer.h
